#!/usr/bin/perl

use warnings;
use strict;
use Data::Dumper;
use LWP::UserAgent;
use HTTP::Request::Common;

my ($url, $server, $branch, $email, $author, $keyfile) = @ARGV;

die "Syntax: $0 URL GITREMOTE GITBRANCH GITEMAIL GITAUTHOR KEYFILE

Example:

$0 http://admin:admin\@127.0.0.1:80/api/dc/workspace/settings /var/tmp/masterfiles.git master git\@cfengine.com 'The Git Workflow' /tmp/id_rsa

"
 unless defined $keyfile;

die "$0: can't read $keyfile" unless -r $keyfile;

my $ua = LWP::UserAgent->new();

my $post = POST $url,
 Content_Type => 'form-data',
 Content =>
 [
  gitServer => $server,
  gitBranch => $branch,
  gitEmail => $email,
  gitAuthor => $author,
  gitPrivateKey => [$keyfile]
 ];

print "\nMaking HTTP POST request: " . Dumper(\@ARGV);
print Dumper $post;
my $response = $ua->request($post);

my $content  = $response->decoded_content();
print "\n\nResponse:\n\n", $content, "\n";
