<?php

/**
 * Class CfTasks
 */
class CfTasks
{

    /** @var PDO $connection */
    private $cfSettings;

    /** @var PDO $connection */
    private $cfdbConnection;


    /**
     * CfTasks constructor.
     */
    public function __construct()
    {
        $this->cfdbConnection = CfdbPdo::getInstance()->getConnection();
        $this->cfSettings = CfSettings::getInstance();
    }

    /**
     * Clean up __lastseenhostslog table
     */
    public function cleanupLastSeenHostsLogs()
    {
        $readOnlyData = $this->cfdbConnection->query('SELECT pg_is_in_recovery() as in_recovery,  pg_is_in_backup() as in_backup')->fetch(PDO::FETCH_ASSOC);
        if ($readOnlyData['in_recovery'] == true || $readOnlyData['in_backup']  == true) {
            $errorMessage = 'PostgreSQL is in backup or recovery, skipping cleanup LastSeenHostsLogs';
            syslog(LOG_DEBUG, $errorMessage);
            return false;
        }

        $numberOfRuns = $this->cfSettings->getSetting('sameHostsNumberOfRuns');
        if($numberOfRuns == null){
            $numberOfRuns = 3;
        }

        $allHostKeys = $this->cfdbConnection->query('SELECT DISTINCT hostkey  FROM "__lastseenhostslogs"')->fetchAll(PDO::FETCH_ASSOC);
        foreach ($allHostKeys as  $host){
            $hostKey = $host['hostkey'];
            $this->cfdbConnection->query("DELETE  FROM __lastseenhostslogs WHERE hostkey = '$hostKey' AND id NOT IN (SELECT id FROM __lastseenhostslogs WHERE hostkey = '$hostKey' ORDER BY lastseentimestamp DESC LIMIT $numberOfRuns)");
        }
        return true;
    }
}