<?php

class SettingsHelper
{

    /** @var array */
    protected static $allowedSettings = [
        'rbacEnabled',
        'ldapEnabled',
        'hostIdentifier',
        'blueHostHorizon',
        'sameHostsNumberOfRuns',
        'logLevel'
    ];

    /**
     * Remove LDAP Password from settings
     *
     * @param $settings
     * @return string
     */
    public static function removeLdapPassword($settings)
    {
        if (is_string($settings)) {
            $settings = json_decode($settings);
            if (isset($settings->data) && isset($settings->data[0]) && isset($settings->data[0]->ldapPassword)) {
                unset($settings->data[0]->ldapPassword);
            }
        }
        return json_encode($settings, JSON_PRETTY_PRINT);
    }

    /**
     * Remove not allowed settings
     *
     * @param $data
     */
    public static function removeUnAllowedSettings( &$data ) {
        foreach ( $data as $key => $value ) {
            if ( ! in_array( $key, self::$allowedSettings ) ) {
                unset( $data[ $key ] );
            }
        }
    }
}