<?php
class sketchRequestCommand
{

    public $version = '3.6.0';
    public $request = array();

    public function setRequest($requestCommandArray)
    {
        $this->request = $requestCommandArray;
    }

    public function getCommand()
    {

        $commandObj = new stdClass;
        $commandObj->dc_api_version = $this->version;
        $commandObj->request = $this->request;

        return $commandObj;
    }

    function searchAll($filter = true)
    {

        $listCommand = new stdClass();
        $listCommand->describe = true;
        if (is_array($filter) && !empty($filter))
        {
            $filter = $filter;
        }
        else
        {
            $filter = true;
        }
        $listCommand->search = $filter;
        $this->setRequest($listCommand);
    }

    function getSketchInformation($sketch)
    {
        $command = new stdClass();
        $command->describe = true;
        $command->search = array(
            array(
                "name",
                "equals",
                $sketch
            )
        );
        $this->setRequest($command);
    }

    function getActivations()
    {
        $command = new stdClass();
        $command->activations = true;
        $this->setRequest($command);
    }

    function activateSketch($sketchName, $target, $environment, $bundle, $params, $metaData = array())
    {
        $command = new stdClass();
        $activateParams[$sketchName] = array(
            'target' => $target,
            'environment' => $environment,
            'params' => $params,
            'metadata' => $metaData,
            'bundle' => $bundle,
            'identifier' => $metaData['identifier']
        );
        $command->activate = $activateParams;
        $this->setRequest($command);
    }

    function install($sketchName, $source, $target, $force)
    {

        $command = new stdClass();
        $installParams = array(
            array(
                'sketch' => $sketchName,
                'target' => $target,
                'force' => $force,
                'source' => $source
            )
        );
        $command->install = $installParams;
        $this->setRequest($command);
    }

    function uninstall($sketchName, $target)
    {
        $command = new stdClass();
        $uninstallParams = array(
            array(
                'sketch' => $sketchName,
                'target' => $target
            )
        );
        $command->uninstall = $uninstallParams;
        $this->setRequest($command);
    }

    function defineParam($sketchName, $paramName, $params = array())
    {
        if (empty($params))
        {
            $params = new stdClass(); // api expects object, assoc array are automatically objects


        }
        $command = new stdClass();
        $varName = $paramName;
        $defineParam[$varName] = array(
            $sketchName => $params
        );
        $command->define = $defineParam;
        $this->setRequest($command);
    }

    function undefineParam($paramNameArray = array())
    {

        $command = new stdClass();
        $command->undefine = $paramNameArray;
        $this->setRequest($command);
    }

    function getDefinitions()
    {
        $command = new stdClass();
        $command->definitions = true;
        $this->setRequest($command);
    }

    function defineEnvironment($envName, $environment = array())
    {

        $command = new stdClass();
        $defineParam[$envName] = array(
            'activated' => array(
                'include' => $environment,
                'exclude' => array()
            ) ,
            'test' => false,
            'verbose' => false
        );
        $command->define_environment = $defineParam;
        $this->setRequest($command);
    }

    function undefineEnvironment($environments = array())
    {

        $command = new stdClass();
        $command->undefine_environment = $environments;
        $this->setRequest($command);
    }

    function getEnvironments()
    {
        $command = new stdClass();
        $command->environments = true;
        $this->setRequest($command);
    }

    function regenerate()
    {
        $command = new stdClass();
        $command->regenerate = true;
        $this->setRequest($command);
    }

    function getValidations()
    {
        $command = new stdClass();
        $command->validations = true;
        $this->setRequest($command);
    }

    function validate($validationType, $validationData)
    {
        $command = new stdClass();
        $validationArray = array(
            'validation' => $validationType,
            'data' => $validationData
        );
        $command->validate = $validationArray;
        $this->setRequest($command);
    }

    function deactivate($id)
    {
        $command = new stdClass();
        $command->deactivate = $id;
        $this->setRequest($command);
    }

    function generateJson()
    {
        $command = $this->getCommand();

        return json_encode($command);
    }
}
?>