<?php

/**
 * Class HostsUsingSameIdentitySqlBuilder
 */
class HostsUsingSameIdentitySqlBuilder extends BaseHealthDiagnosticSqlBuilder
{
    /**
     * @var string
     */
    protected $sql = 'SELECT SameHosts.HostKey 
                      FROM (
                          SELECT remotehostkey as HostKey FROM lastseenhostslogs GROUP BY remotehostkey HAVING COUNT(distinct remotehostip) > 1
                          ) AS SameHosts
                      WHERE hostkey NOT IN (SELECT hostkey FROM health_diagnostics_dismissed WHERE username = \'%s\' AND report_type = \'%s\' )';

    /**
     * @var string
     */
    protected $nonOverlappedSql;

    /**
     * @var string
     */
    protected $reportSql = 'SELECT sameHosts.Hostkey as key, vm_hosts.hostname as "Host name", sameHosts.ips as "Detected IP addresses" 
                             FROM (SELECT  remotehostkey as Hostkey, array_agg(distinct remotehostip::TEXT) as ips  FROM lastseenhostslogs GROUP BY remotehostkey HAVING COUNT(distinct remotehostip) > 1) as sameHosts 
                             LEFT JOIN vm_hosts ON  vm_hosts.hostkey = sameHosts.hostkey 
                             ';


    /**
     * @return string
     */
    public function getSql(): string
    {
        $sql = sprintf($this->sql, $this->userName, BaseHealthDiagnostic::SAME_IDENTITY_TYPE);
        return $sql;
    }

    /**
     * Extend report sql by adding where in (report sql).
     * It needs to include in report only needed hosts.
     *
     * @return string
     */
    public function getReportSql(): string
    {
        $this->reportSql = sprintf($this->reportSql . ' WHERE sameHosts.HostKey IN (%s)', $this->getNonOverlappedSql());

        return $this->reportSql;
    }

}