<?php
require_once __DIR__ . '/../../lib/Pest.php';
require_once __DIR__ . '/../../services/CFAuthService.php';

class OauthCfPdo extends OAuth2\Storage\Pdo
{
    public $username = null;

    public function getUser($username)
    {

        $userInfo = array();
        // the default behavior is to use "username" as the user_id
        return array_merge(array(
            'user_id' => $username
        ) , $userInfo);
    }

    public function checkUserCredentials($username, $password)
    {
        $cfAuthService = new CFAuthService();
        return $this->username = $cfAuthService->auth($username, $password);
    }

    public function getUserDetails($username)
    {
        return $this->getUser($this->username);
    }

    public function unsetAccessToken($access_tokens)
    {
        if (empty($access_tokens))
        {
            return true;
        }

        $place_holders = implode(',', array_fill(0, count($access_tokens) , '?'));

        $stmt = $this->db->prepare(sprintf('DELETE FROM %s WHERE access_token IN (%s)', $this->config['access_token_table'], $place_holders));

        return $stmt->execute($access_tokens);
    }

    public function getActiveTokens()
    {
        $stmt = $this->db->prepare(sprintf("select json_agg(a) as details, a.user_id,count(a.access_token) as total_tokens from oauth_access_tokens a where expires > now() AT TIME ZONE 'UTC' GROUP BY user_id"));
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }
}

