<?php

/**
 * Class InternalTasks
 */
class InternalTasks extends CfProtectedResource {
	/**
	 * Cfe_robot user name
	 */
	const CFE_ROBOT_USER = 'CFE_ROBOT';
	/**
	 * @var CfTasks
	 */
	protected $cfTasksLib;

	/**
	 * InternalTasks constructor.
	 *
	 * @param $parameters
	 *
	 * @throws Exception
	 */
	public function __construct( $parameters ) {
		parent::__construct( $parameters );

		$user = $this->username;
		if ( $user != self::CFE_ROBOT_USER ) {
			throw new Exception( 'You are not permitted to access this resource.' );
		}

		$this->cfTasksLib = new CfTasks();
	}
}

/**
 * @uri /internal-tasks/cleanup-lastseenhostslog
 */
class CleanupLastSeenHostsLog extends InternalTasks {

	function get( $request ) {

		$response = new Response( $request );

		try{
		    $this->cfTasksLib->cleanupLastSeenHostsLogs();
		}catch (Exception $e){
			syslog(LOG_ERR, $e->getTraceAsString());
			$response->body = json_encode($e->getMessage());
			$response->code = Response::INTERNALSERVERERROR;
			return $response;
		}

		return $response;
	}
}

