<?php

class Assets_model extends Cf_Model
{
    public function getSoftwareInstalledParams($hostkey)
    {
        return [
            'fields' =>
                [
                    'Hosts.HostName' =>
                        [
                            'name' => 'HostName',
                            'label' => 'Host name',
                            'inputType' => 'text',
                            'table' => 'Hosts',
                            'sqlField' => 'Hosts.HostName',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'Software.SoftwareArchitecture' =>
                        [
                            'name' => 'SoftwareArchitecture',
                            'label' => 'Software architecture',
                            'inputType' => 'text',
                            'table' => 'Software',
                            'sqlField' => 'Software.SoftwareArchitecture',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'Software.SoftwareName' =>
                        [
                            'name' => 'SoftwareName',
                            'label' => 'Software name',
                            'inputType' => 'text',
                            'table' => 'Software',
                            'sqlField' => 'Software.SoftwareName',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'Software.SoftwareVersion' =>
                        [
                            'name' => 'SoftwareVersion',
                            'label' => 'Software version',
                            'inputType' => 'text',
                            'table' => 'Software',
                            'sqlField' => 'Software.SoftwareVersion',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                ],
            'filters' =>
                [
                        [
                            'name' => 'HostKey',
                            'label' => 'Host key',
                            'inputType' => 'text',
                            'table' => 'Hosts',
                            'sqlField' => 'Hosts.HostKey',
                            'dataType' => 'string',
                            'isSelected' => false,
                            'logical' => 'AND',
                            'comparison' => '=',
                            '$$hashKey' => '098',
                            'value' => $hostkey,
                        ],
                ],
            'groupby' => [],
            'orderby' => [],
            'limit' => '',
            'SQLSTRING' => 'SELECT Hosts.HostName AS "Host name", Software.SoftwareArchitecture AS "Software architecture", Software.SoftwareName AS "Software name", Software.SoftwareVersion AS "Software version", Software.ChangeTimeStamp AS "Discovered at (UTC)"
                            FROM Software 
                            INNER JOIN Hosts ON Hosts.HostKey = Software.HostKey 
                            WHERE  Hosts.HostKey = \'' . $hostkey . '\'',
        ];
    }

    public function getAvailableSoftwareParams($hostkey)
    {
        return [
            'fields' =>
                [
                    'Hosts.HostName' =>
                        [
                            'name' => 'HostName',
                            'label' => 'Host name',
                            'inputType' => 'text',
                            'table' => 'Hosts',
                            'sqlField' => 'Hosts.HostName',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'SoftwareUpdates.PatchName' =>
                        [
                            'name' => 'PatchName',
                            'label' => 'Update name',
                            'inputType' => 'text',
                            'table' => 'SoftwareUpdates',
                            'sqlField' => 'SoftwareUpdates.PatchName',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'SoftwareUpdates.PatchVersion' =>
                        [
                            'name' => 'PatchVersion',
                            'label' => 'Update version',
                            'inputType' => 'text',
                            'table' => 'SoftwareUpdates',
                            'sqlField' => 'SoftwareUpdates.PatchVersion',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'SoftwareUpdates.PatchArchitecture' =>
                        [
                            'name' => 'PatchArchitecture',
                            'label' => 'Architecture',
                            'inputType' => 'text',
                            'table' => 'SoftwareUpdates',
                            'sqlField' => 'SoftwareUpdates.PatchArchitecture',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                    'SoftwareUpdates.PatchReportType' =>
                        [
                            'name' => 'PatchReportType',
                            'label' => 'Update type',
                            'inputType' => 'text',
                            'table' => 'SoftwareUpdates',
                            'sqlField' => 'SoftwareUpdates.PatchReportType',
                            'dataType' => 'string',
                            'isSelected' => true,
                        ],
                ],
            'filters' =>
                [
                        [
                            'name' => 'PatchReportType',
                            'label' => 'Patch-report type',
                            'inputType' => 'text',
                            'table' => 'SoftwareUpdates',
                            'sqlField' => 'SoftwareUpdates.PatchReportType',
                            'dataType' => 'string',
                            'isSelected' => true,
                            'logical' => 'AND',
                            'comparison' => '=',
                            '$$hashKey' => '05N',
                            'value' => 'AVAILABLE',
                        ],
                        [
                            'name' => 'HostKey',
                            'label' => 'Host key',
                            'inputType' => 'text',
                            'table' => 'Hosts',
                            'sqlField' => 'Hosts.HostKey',
                            'dataType' => 'string',
                            'isSelected' => false,
                            'logical' => 'AND',
                            'comparison' => '=',
                            '$$hashKey' => '05R',
                            'value' => $hostkey,
                        ],
                ],
            'groupby' => [],
            'orderby' => [],
            'limit' => '',
            'SQLSTRING' => 'SELECT Hosts.HostName AS "Host name", SoftwareUpdates.PatchName AS "Software name", SoftwareUpdates.PatchVersion AS "Software version", SoftwareUpdates.PatchArchitecture AS "Software architecture", SoftwareUpdates.ChangeTimeStamp AS "Discovered at (UTC)"
                            FROM SoftwareUpdates 
                            INNER JOIN Hosts ON Hosts.HostKey = SoftwareUpdates.HostKey 
                            WHERE  SoftwareUpdates.PatchReportType = \'AVAILABLE\' AND Hosts.HostKey = \'' . $hostkey . '\'',
            'hostcontexts' =>
                [
                    'name' => 'All hosts',
                    'includes' => [],
                    'isHosts' => false,
                ],
            'excludedHosts' => '',
        ];
    }
}