<div class="settingsPage">

    <div class="left-column">
        <?php include('settingsSideBar.php'); ?>
    </div>

    <div class="right-column">

        <div class="pageTitle">
            <h1><span>Authentication settings</span></h1>
        </div>

        <div class="pullTop">

            <?php

            if (($this->session->flashdata('message')) || is_array($message)) {
                $flashMessage = $this->session->flashdata('message') ? $this->session->flashdata('message') : $message;
                $content = $flashMessage['content'];
                $content_class = $flashMessage['type'];
                ?>
                <div style="margin-top: 13px;">
                    <div class="alert <?php echo $content_class; ?>">
                        <button class="close" data-dismiss="alert">×</button>
                        <?php echo $content; ?>
                    </div>
                </div>

            <?php } ?>
        </div>

        <form class="form-horizontal">

            <div class="control-group">
                <label class="control-label" for="authentication">Authentication method</label>
                <div class="controls">
                    <label class="radio inline">
                        <?php
                        $elem = array(
                            'name' => 'mode',
                            'id' => 'mode1',
                            'class' => 'radio',
                            'value' => 'internal',
                            'checked' => (isset($mode) && $mode === 'internal' ? TRUE : $this->form_validation->set_radio('mode', 'internal'))
                        );
                        echo form_radio($elem);
                        ?>
                        Internal
                    </label>

                    <label for="mode" class="radio inline">

                        <?php
                        $elem = array(
                            'name' => 'mode',
                            'id' => 'mode2',
                            'class' => 'radio',
                            'value' => 'ldap',
                            'checked' => (isset($mode) && $mode === 'ldap' ? TRUE : $this->form_validation->set_radio('mode', 'ldap'))
                        );
                        echo form_radio($elem);
                        ?>
                        LDAP
                    </label>
                </div>
            </div>
        </form>


        <div class="ldap-form">

            <h5 class="activate-msg" <?php if ($is_ldap_available) { ?> style="display: none" <?php } ?>>LDAP API settings are incorrect.
                See application log for details.</h5>

            <?php
            $attributes = array('class' => 'form-horizontal', 'id' => 'mpsettings', 'autocomplete' => "off");
            echo form_open_multipart('settings/ldap_api_settings', $attributes);
            ?>
            <fieldset id="ldapsettings" class="border-bottom">
                <div class="control-group required">
                    <label class="control-label" for="domain_controller">Ldap Host</label>
                    <div class="controls">
                        <input id="domain_controller" type="text" name="domain_controller" class="input-xlarge"
                               value="<?php echo $domain_controller; ?>"/>
                        <p class="help-block"> <?php echo tooltip('tooltip_host_name'); ?></p>
                    </div>
                </div>

                <div class="control-group required">
                    <label class="control-label" for="port">Port</label>
                    <div class="controls">
                        <input id="port" type="text" name="port" class="input-xlarge" value="<?php echo $port; ?>"/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="encryption">Encryption</label>
                    <div class="controls">
                        <label class="radio inline">
                            <?php
                            $elem = array(
                                'name' => 'encryption',
                                'id' => 'sec1',
                                'class' => 'radio',
                                'value' => 'plain',
                                'checked' => (isset($encryption) && $encryption === 'plain' ? TRUE : '')
                            );
                            echo form_radio($elem);
                            ?>
                            None
                        </label>

                        <label for="encryption" class="radio inline">
                            <?php
                            $elem = array(
                                'name' => 'encryption',
                                'id' => 'sec2',
                                'value' => 'ssl',
                                'class' => 'radio',
                                'checked' => (isset($encryption) && $encryption === 'ssl' ? TRUE : '')
                            );
                            echo form_radio($elem);
                            ?>
                            SSL
                        </label>

                        <label for="encryption" class="radio inline">
                            <?php
                            $elem = array(
                                'name' => 'encryption',
                                'id' => 'sec3',
                                'value' => 'tls',
                                'class' => 'radio',
                                'checked' => (isset($encryption) && $encryption === 'tls' ? TRUE : '')
                            );
                            echo form_radio($elem);
                            ?>
                            STARTTLS
                        </label>
                    </div>
                </div>
                <div class="control-group required">
                    <label class="control-label" for="base_dn">Base DN</label>
                    <div class="controls">
                        <input id="base_dn" type="text" name="base_dn"
                               class="input-xlarge" value="<?php echo $base_dn; ?>"/>
                        <p class="help-block"> <?php echo tooltip('tooltip_base_dn'); ?></p>
                    </div>
                </div>

                <div class="control-group required">
                    <label class="control-label" for="host">Login attribute</label>
                    <div class="controls">
                        <input id="login_attribute" type="text" name="login_attribute" class="input-xlarge"
                               value="<?php echo $login_attribute; ?>"/>
                        <p class="help-block"><?php echo tooltip('tooltip_login_attr'); ?></p>
                    </div>
                </div>
                <div class="control-group">
                    <label class="control-label" for="host">Ldap filter</label>
                    <div class="controls">
                        <input id="ldap_filter" type="text" name="ldap_filter" class="input-xlarge"
                               value="<?php echo $ldap_filter; ?>"/>
                        <p class="help-block"><?php echo tooltip('tooltip_ldap_search_filter'); ?></p>
                    </div>
                </div>
                <div class="control-group required">
                    <label class="control-label" for="admin_username">LDAP bind user name</label>
                    <div class="controls">
                        <input id="admin_username" type="text" name="admin_username" class="input-xlarge"
                               value="<?php echo(isset($admin_username) ? $admin_username : '') ?>"/>
                        <p class="help-block"><?php echo tooltip('tooltip_external_admin_username'); ?></p>
                    </div>
                </div>

                <div class="control-group required">
                    <label class="control-label" for="admin_password">LDAP bind password</label>
                    <div class="controls">
                        <input id="admin_password" type="password" autocomplete="new-password" class="input-xlarge"
                               onchange="this.setAttribute('name', 'admin_password')"
                               placeholder="<?= $admin_password ?>"/>
                    </div>
                </div>
                <?php echo form_submit(array(
                    'name' => 'submit',
                    'class' => 'btn apply-button btn-primary btn-large pull-right',
                    'value' => 'Apply'
                )); ?>
            </fieldset>

            <?php echo form_close(); ?>

        </div>
    </div>
</div>
<?php if (!$is_ldap_available) { ?>
    <script>
        $('#mpsettings input').attr('disabled', 'disabled');
    </script>
<?php } ?>
<script src="/scripts/notify.min.js"></script>
<script src="/scripts/authentication-settings.js"></script>
