'use strict';

dashboardApp.directive('inventoryWidget', ['inventoryWidgetHelper', '$q', function (inventoryWidgetHelper) {
    return {
        templateUrl: MP_SITE_URL + '/dashboard/partials/inventory_widget',
        restrict: 'A',
        scope: {
            widget: '=',
            currentUser: "=",
            inventoryVariable: "=",
            currentDash: "=",
            saveOldName: '&',
            editName: '&',
            deleteWidget: '&',

        },
        link: function (scope, element) {

            var helper = inventoryWidgetHelper;
            scope.$watch(function () {
                return element.attr('refresh');
            }, function () {
                helper.getInventoryStats({"attributeName": scope.widget.payload.inventoryAttribute}).then(
                    function (result) {
                        helper.setVariable(scope.widget.payload.inventoryAttribute);
                        scope.widget.chartList = helper.getChartData(scope.widget.payload.chartType, result);
                    }
                );
            });


        }
    };

}]);