$('html').on('host-page-loaded', function () {
    let hostkey = $('.host_id_SE').text().replace('SHA=', '');
    let updateInventoryValue = function (hostkey, attribute) {
        let data = {
            "select": [attribute],
            "start": 0,
            "limit": 1,
            "showSQL": false,
            "hostContextInclude": [hostkey],
            "hostContextExclude": []
        };
        $.ajax({
            type: "POST",
            url: '/advancedreports/inventory/data',
            dataType: 'json',
            data: JSON.stringify(data)
        }).done(function (response) {
            let value = (response.rows != undefined && response.rows.length > 0) ? response.rows[0][0] : 'n/a';
            $('#host-inventory-data').html(value);
            $('.inventory-report-btn').data('attribute', attribute).data('hostkey', hostkey)
        });
    }

    $.ajax({
        type: "GET",
        url: '/advancedreports/inventory/variables',
        dataType: 'json'
    }).done(function (response) {
        let result = {}
        let isValueUpdated = false;
        response.forEach(function (attr) {
            if (!isValueUpdated) {
                updateInventoryValue(hostkey, attr.attribute_name);
                isValueUpdated = true;
            }
            if (result[attr.category] == undefined) {
                result[attr.category] = [attr.attribute_name]
            } else {
                result[attr.category].push(attr.attribute_name)
            }
        })

        let selectHtml = '';
        Object.keys(result).forEach(function (group) {
            selectHtml += '<optgroup label="' + group + '">';
            result[group].forEach(function (attributeName) {
                selectHtml += '<option value="' + attributeName + '">' + attributeName + '</option>';
            });
            selectHtml += '</optgroup>';
        })
        $('.chosen-select').append(selectHtml);

        $(".chosen-select").chosen({disable_search_threshold: 10}).change(function (event, data) {
            updateInventoryValue(hostkey, data.selected);
        });
    });

    $('.inventory-report-btn').click(function () {
        let el = $(this);
        window.open(
            encodeURI(el.data('url') + ',' + el.data('attribute') + '&include=' + el.data('hostkey').trim()),
            '_blank'
        );
    });

    let openModal = function (event) {
        var userModalBody = {
            'header': '<h2>' + event.data.type.capitalizeFirstLetter() + ' defined on ' + $('.host_alias').text().trim().htmlSpecialChars() + '</h2>',
            'body_url': MP_SITE_URL + '/advancedreports/renderTable/' + event.data.type + '/' + $('.host_id_SE').text().trim()
        };
        var mainDialog = bootbox.dialog('', [], userModalBody).css({
            'width': function () {
                return ($(document).width() * 0.6) + 'px';
            },
            'margin-left': function () {
                return -($(this).width() / 2);
            }
        });
        mainDialog.find('.modal-body').addClass('form-buttons').css('height', ($(document).height() * 0.4) + 'px');
    };

    $('.show-classes').click({type: 'classes'}, openModal);
    $('.show-variables').click({type: 'variables'}, openModal);

});
